> ## Documentation Index
> Fetch the complete documentation index at: https://algolia.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Retrieve recommendations

> Retrieves recommendations from selected AI models.

**Required ACL:** `search`


## OpenAPI

````yaml specs/recommend.yml post /1/indexes/*/recommendations
openapi: 3.1.0
info:
  title: Recommend API
  summary: >-
    The Recommend API lets you retrieve recommendations from one of Algolia's AI
    recommendation models that you previously trained on your data
  description: >
    ## Client libraries


    Use Algolia's API clients and libraries to reliably integrate Algolia's APIs
    with your apps.

    The official API clients are covered by Algolia's [Service Level
    Agreement](https://www.algolia.com/policies/sla).


    For more information, see [Algolia's
    ecosystem](https://www.algolia.com/doc/libraries).


    ## Base URLs


    Base URLs for the Recommend API:


    - `https://{APPLICATION_ID}.algolia.net`

    - `https://{APPLICATION_ID}-dsn.algolia.net`.
      If your subscription includes a [Distributed Search Network](https://dashboard.algolia.com/infra),
      this ensures that requests are sent to servers closest to users.

    Both URLs provide high availability by distributing requests with load
    balancing.


    **All requests must use HTTPS.**


    ## Retry strategy


    To guarantee a high availability, implement a retry strategy for all API
    requests using the URLs of your servers as fallbacks:


    - `https://{APPLICATION_ID}-1.algolianet.com`

    - `https://{APPLICATION_ID}-2.algolianet.com`

    - `https://{APPLICATION_ID}-3.algolianet.com`


    These URLs use a different DNS provider than the primary URLs.

    Randomize this list to ensure an even load across the three servers.


    All Algolia API clients implement this retry strategy.


    ## Authentication


    Add these headers to authenticate requests:


    - `x-algolia-application-id`. Your Algolia application ID.

    - `x-algolia-api-key`. An API key with the necessary permissions to make the
    request.
      The required access control list (ACL) to make a request is listed in each endpoint's reference.

    You can find your application ID and API key in the [Algolia
    dashboard](https://dashboard.algolia.com/account/api-keys).


    ## Request format


    Request bodies must be JSON objects.


    ## Response status and errors


    The Recommend API returns JSON responses.

    Since JSON doesn't guarantee any specific ordering, don't rely on the order
    of attributes in the API response.


    Successful responses return `2xx` statuses. Client errors return `4xx`
    statuses. Server errors return `5xx` statuses.

    Error responses have a `message` property with more information.


    ## Version


    The current version of the Recommend API is version 1, indicated by the
    `/1/` in each endpoint's URL.
  version: 1.0.0
servers:
  - url: https://{appId}.algolia.net
    variables:
      appId:
        default: ALGOLIA_APPLICATION_ID
  - url: https://{appId}-1.algolianet.com
    variables:
      appId:
        default: ALGOLIA_APPLICATION_ID
  - url: https://{appId}-2.algolianet.com
    variables:
      appId:
        default: ALGOLIA_APPLICATION_ID
  - url: https://{appId}-3.algolianet.com
    variables:
      appId:
        default: ALGOLIA_APPLICATION_ID
  - url: https://{appId}-dsn.algolia.net
    variables:
      appId:
        default: ALGOLIA_APPLICATION_ID
security:
  - appId: []
    apiKey: []
tags:
  - name: recommendations
    x-displayName: Recommendations
    description: >-
      Retrieve recommendations from a pre-trained AI model. You can train models
      in the [Algolia dashboard](https://dashboard.algolia.com/recommend).
    externalDocs:
      url: https://www.algolia.com/doc/guides/algolia-recommend/overview
      description: Algolia Recommend.
  - name: rules
    x-displayName: Rules
    description: Curate your recommendations with rules, which are _if_-_then_ statements.
    externalDocs:
      url: https://www.algolia.com/doc/guides/algolia-recommend/how-to/rules
      description: Recommend Rules.
paths:
  /1/indexes/*/recommendations:
    post:
      tags:
        - recommendations
      summary: Retrieve recommendations
      description: |
        Retrieves recommendations from selected AI models.
      operationId: getRecommendations
      requestBody:
        required: true
        content:
          application/json:
            schema:
              title: getRecommendationsParams
              description: Recommend request body.
              type: object
              additionalProperties: false
              properties:
                requests:
                  type: array
                  description: >-
                    Recommendation request with parameters depending on the
                    requested model.
                  items:
                    $ref: '#/components/schemas/recommendationsRequest'
              required:
                - requests
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                title: getRecommendationsResponse
                type: object
                additionalProperties: false
                properties:
                  results:
                    type: array
                    items:
                      $ref: '#/components/schemas/recommendationsResults'
                required:
                  - results
        '400':
          $ref: '#/components/responses/BadRequest'
        '402':
          $ref: '#/components/responses/FeatureNotEnabled'
        '403':
          $ref: '#/components/responses/MethodNotAllowed'
        '404':
          $ref: '#/components/responses/IndexNotFound'
      x-codeSamples:
        - lang: csharp
          label: C#
          source: |-
            // Initialize the client
            var client = new RecommendClient(
              new RecommendConfig("ALGOLIA_APPLICATION_ID", "ALGOLIA_API_KEY")
            );

            // Call the API
            var response = await client.GetRecommendationsAsync(
              new GetRecommendationsParams
              {
                Requests = new List<RecommendationsRequest>
                {
                  new RecommendationsRequest(
                    new RelatedQuery
                    {
                      IndexName = "<YOUR_INDEX_NAME>",
                      ObjectID = "objectID",
                      Model = Enum.Parse<RelatedModel>("RelatedProducts"),
                      Threshold = 42.1,
                    }
                  ),
                },
              }
            );

            // print the response
            Console.WriteLine(response);
        - lang: dart
          label: Dart
          source: |-
            // Initialize the client
            final client = RecommendClient(
                appId: 'ALGOLIA_APPLICATION_ID', apiKey: 'ALGOLIA_API_KEY');

            // Call the API
            final response = await client.getRecommendations(
              getRecommendationsParams: GetRecommendationsParams(
                requests: [
                  RelatedQuery(
                    indexName: "<YOUR_INDEX_NAME>",
                    objectID: "objectID",
                    model: RelatedModel.fromJson("related-products"),
                    threshold: 42.1,
                  ),
                ],
              ),
            );

            // print the response
            print(response);
        - lang: go
          label: Go
          source: >-
            // Initialize the client

            client, err := recommend.NewClient("ALGOLIA_APPLICATION_ID",
            "ALGOLIA_API_KEY")

            if err != nil {
              // The client can fail to initialize if you pass an invalid parameter.
              panic(err)
            }


            // Call the API

            response, err :=
            client.GetRecommendations(client.NewApiGetRecommendationsRequest(

              recommend.NewEmptyGetRecommendationsParams().SetRequests(
                []recommend.RecommendationsRequest{*recommend.RelatedQueryAsRecommendationsRequest(
                  recommend.NewEmptyRelatedQuery().SetIndexName("<YOUR_INDEX_NAME>").SetObjectID("objectID").SetModel(recommend.RelatedModel("related-products")).SetThreshold(42.1))})))
            if err != nil {
              // handle the eventual error
              panic(err)
            }



            // print the response

            print(response)
        - lang: java
          label: Java
          source: >-
            // Initialize the client

            RecommendClient client = new
            RecommendClient("ALGOLIA_APPLICATION_ID", "ALGOLIA_API_KEY");


            // Call the API

            GetRecommendationsResponse response = client.getRecommendations(
              new GetRecommendationsParams().setRequests(
                Arrays.asList(
                  new RelatedQuery()
                    .setIndexName("<YOUR_INDEX_NAME>")
                    .setObjectID("objectID")
                    .setModel(RelatedModel.RELATED_PRODUCTS)
                    .setThreshold(42.1)
                )
              )
            );


            // print the response

            System.out.println(response);
        - lang: javascript
          label: JavaScript
          source: >-
            // Initialize the client

            const client = algoliasearch('ALGOLIA_APPLICATION_ID',
            'ALGOLIA_API_KEY').initRecommend();


            // Call the API

            const response = await client.getRecommendations({
              requests: [{ indexName: 'indexName', objectID: 'objectID', model: 'related-products', threshold: 42.1 }],
            });



            // print the response

            console.log(response);
        - lang: kotlin
          label: Kotlin
          source: >-
            // Initialize the client

            val client = RecommendClient(appId = "ALGOLIA_APPLICATION_ID",
            apiKey = "ALGOLIA_API_KEY")


            // Call the API

            var response =
              client.getRecommendations(
                getRecommendationsParams =
                  GetRecommendationsParams(
                    requests =
                      listOf(
                        RelatedQuery(
                          indexName = "<YOUR_INDEX_NAME>",
                          objectID = "objectID",
                          model = RelatedModel.entries.first { it.value == "related-products" },
                          threshold = 42.1,
                        )
                      )
                  )
              )


            // print the response

            println(response)
        - lang: php
          label: PHP
          source: >-
            // Initialize the client

            $client = RecommendClient::create('ALGOLIA_APPLICATION_ID',
            'ALGOLIA_API_KEY');


            // Call the API

            $response = $client->getRecommendations(
                ['requests' => [
                    ['indexName' => '<YOUR_INDEX_NAME>',
                        'objectID' => 'objectID',
                        'model' => 'related-products',
                        'threshold' => 42.1,
                    ],
                ],
                ],
            );



            // print the response

            var_dump($response);
        - lang: python
          label: Python
          source: >-
            # Initialize the client

            # In an asynchronous context, you can use RecommendClient instead,
            which exposes the exact same methods.

            client = RecommendClientSync("ALGOLIA_APPLICATION_ID",
            "ALGOLIA_API_KEY")


            # Call the API

            response = client.get_recommendations(
                get_recommendations_params={
                    "requests": [
                        {
                            "indexName": "<YOUR_INDEX_NAME>",
                            "objectID": "objectID",
                            "model": "related-products",
                            "threshold": 42.1,
                        },
                    ],
                },
            )



            # print the response

            print(response)
        - lang: ruby
          label: Ruby
          source: >-
            # Initialize the client

            client = Algolia::RecommendClient.create("ALGOLIA_APPLICATION_ID",
            "ALGOLIA_API_KEY")


            # Call the API

            response = client.get_recommendations(
              Algolia::Recommend::GetRecommendationsParams.new(
                requests: [
                  Algolia::Recommend::RelatedQuery.new(
                    index_name: "<YOUR_INDEX_NAME>",
                    algolia_object_id: "objectID",
                    model: "related-products",
                    threshold: 42.1
                  )
                ]
              )
            )



            # print the response

            puts(response)
        - lang: scala
          label: Scala
          source: >-
            // Initialize the client

            val client = RecommendClient(appId = "ALGOLIA_APPLICATION_ID",
            apiKey = "ALGOLIA_API_KEY")


            // Call the API

            val response = Await.result(
              client.getRecommendations(
                getRecommendationsParams = GetRecommendationsParams(
                  requests = Seq(
                    RelatedQuery(
                      indexName = "<YOUR_INDEX_NAME>",
                      objectID = "objectID",
                      model = RelatedModel.withName("related-products"),
                      threshold = 42.1
                    )
                  )
                )
              ),
              Duration(100, "sec")
            )


            // print the response

            println(response)
        - lang: swift
          label: Swift
          source: >-
            // Initialize the client

            let client = try RecommendClient(appID: "ALGOLIA_APPLICATION_ID",
            apiKey: "ALGOLIA_API_KEY")


            // Call the API

            let response = try await client
                .getRecommendations(getRecommendationsParams: GetRecommendationsParams(requests: [RecommendationsRequest
                        .relatedQuery(RelatedQuery(
                            indexName: "<YOUR_INDEX_NAME>",
                            threshold: 42.1,
                            model: RelatedModel.relatedProducts,
                            objectID: "objectID"
                        ))]))

            // print the response

            print(response)
        - lang: cURL
          label: curl
          source: |-
            curl --request POST \
              --url 'https://algolia_application_id.algolia.net/1/indexes/*/recommendations' \
              --header 'accept: application/json' \
              --header 'content-type: application/json' \
              --header 'x-algolia-api-key: ALGOLIA_API_KEY' \
              --header 'x-algolia-application-id: ALGOLIA_APPLICATION_ID' \
              --data '
            {
              "requests": [
                {
                  "indexName": "products",
                  "threshold": 0,
                  "maxRecommendations": 30,
                  "queryParameters": {
                    "similarQuery": "comedy drama crime Macy Buscemi",
                    "filters": "(category:Book OR category:Ebook) AND _tags:published",
                    "facetFilters": [
                      [
                        "category:Book",
                        "category:-Movie"
                      ],
                      "author:John Doe"
                    ],
                    "optionalFilters": [
                      "category:Book",
                      "author:John Doe"
                    ],
                    "numericFilters": [
                      [
                        "inStock = 1",
                        "deliveryDate < 1441755506"
                      ],
                      "price < 1000"
                    ],
                    "tagFilters": [
                      [
                        "Book",
                        "Movie"
                      ],
                      "SciFi"
                    ],
                    "sumOrFiltersScores": false,
                    "restrictSearchableAttributes": [
                      "title",
                      "author"
                    ],
                    "facets": [
                      "*"
                    ],
                    "facetingAfterDistinct": false,
                    "aroundLatLng": "40.71,-74.01",
                    "aroundLatLngViaIP": false,
                    "aroundRadius": 1,
                    "aroundPrecision": 10,
                    "minimumAroundRadius": 1,
                    "insideBoundingBox": "lorem",
                    "insidePolygon": [
                      [
                        47.3165,
                        4.9665,
                        47.3424,
                        5.0201,
                        47.32,
                        4.9
                      ],
                      [
                        40.9234,
                        2.1185,
                        38.643,
                        1.9916,
                        39.2587,
                        2.0104
                      ]
                    ],
                    "naturalLanguages": [],
                    "ruleContexts": [
                      "mobile"
                    ],
                    "personalizationImpact": 100,
                    "userToken": "test-user-123",
                    "getRankingInfo": false,
                    "synonyms": true,
                    "clickAnalytics": false,
                    "analytics": true,
                    "analyticsTags": [],
                    "percentileComputation": true,
                    "enableABTest": true,
                    "query": "",
                    "attributesForFaceting": [
                      "author",
                      "filterOnly(isbn)",
                      "searchable(edition)",
                      "afterDistinct(category)",
                      "afterDistinct(searchable(publisher))"
                    ],
                    "replicas": [
                      "virtual(prod_products_price_asc)",
                      "dev_products_replica"
                    ],
                    "paginationLimitedTo": 100,
                    "unretrievableAttributes": [
                      "total_sales"
                    ],
                    "disableTypoToleranceOnWords": [
                      "wheel",
                      "1X2BCD"
                    ],
                    "attributesToTransliterate": [
                      "name",
                      "description"
                    ],
                    "camelCaseAttributes": [
                      "description"
                    ],
                    "decompoundedAttributes": {
                      "de": [
                        "name"
                      ]
                    },
                    "indexLanguages": [
                      "ja"
                    ],
                    "disablePrefixOnAttributes": [
                      "sku"
                    ],
                    "allowCompressionOfIntegerArray": false,
                    "numericAttributesForFiltering": [
                      "equalOnly(quantity)",
                      "popularity"
                    ],
                    "separatorsToIndex": "+#",
                    "searchableAttributes": [
                      "title,alternative_title",
                      "author",
                      "unordered(text)",
                      "emails.personal"
                    ],
                    "userData": {
                      "settingID": "f2a7b51e3503acc6a39b3784ffb84300",
                      "pluginVersion": "1.6.0"
                    },
                    "customNormalization": {
                      "default": {
                        "ä": "ae",
                        "ü": "ue"
                      }
                    },
                    "attributeForDistinct": "url",
                    "maxFacetHits": 10,
                    "keepDiacriticsOnCharacters": "øé",
                    "customRanking": [
                      "desc(popularity)",
                      "asc(price)"
                    ],
                    "attributesToRetrieve": [
                      "author",
                      "title",
                      "content"
                    ],
                    "ranking": [
                      "typo",
                      "geo",
                      "words",
                      "filters",
                      "proximity",
                      "attribute",
                      "exact",
                      "custom"
                    ],
                    "relevancyStrictness": 90,
                    "attributesToHighlight": [
                      "author",
                      "title",
                      "conten",
                      "content"
                    ],
                    "attributesToSnippet": [
                      "content:80",
                      "description"
                    ],
                    "highlightPreTag": "<em>",
                    "highlightPostTag": "</em>",
                    "snippetEllipsisText": "…",
                    "restrictHighlightAndSnippetArrays": false,
                    "minWordSizefor1Typo": 4,
                    "minWordSizefor2Typos": 8,
                    "typoTolerance": true,
                    "allowTyposOnNumericTokens": true,
                    "disableTypoToleranceOnAttributes": [
                      "sku"
                    ],
                    "ignorePlurals": [
                      "ca",
                      "es"
                    ],
                    "removeStopWords": [
                      "ca",
                      "es"
                    ],
                    "queryLanguages": [
                      "es"
                    ],
                    "decompoundQuery": true,
                    "enableRules": true,
                    "enablePersonalization": false,
                    "queryType": "prefixLast",
                    "removeWordsIfNoResults": "firstWords",
                    "advancedSyntax": false,
                    "optionalWords": "lorem",
                    "disableExactOnAttributes": [
                      "description"
                    ],
                    "exactOnSingleWordQuery": "attribute",
                    "alternativesAsExact": [
                      "ignorePlurals",
                      "singleWordSynonym"
                    ],
                    "advancedSyntaxFeatures": [
                      "exactPhrase",
                      "excludeWords"
                    ],
                    "distinct": 1,
                    "replaceSynonymsInHighlight": false,
                    "minProximity": 1,
                    "responseFields": [
                      "*"
                    ],
                    "maxValuesPerFacet": 100,
                    "sortFacetValuesBy": "count",
                    "attributeCriteriaComputedByMinProximity": false,
                    "renderingContent": {
                      "facetOrdering": {
                        "facets": {
                          "order": [
                            "lorem"
                          ]
                        },
                        "values": {
                          "property1": {
                            "order": [
                              "lorem"
                            ],
                            "sortRemainingBy": "count",
                            "hide": [
                              "lorem"
                            ]
                          },
                          "property2": {
                            "order": [
                              "lorem"
                            ],
                            "sortRemainingBy": "count",
                            "hide": [
                              "lorem"
                            ]
                          }
                        }
                      },
                      "redirect": {
                        "url": "lorem"
                      },
                      "widgets": {
                        "banners": [
                          {
                            "image": {
                              "urls": [
                                {
                                  "url": "lorem"
                                }
                              ],
                              "title": "lorem"
                            },
                            "link": {
                              "url": "lorem"
                            }
                          }
                        ]
                      }
                    },
                    "enableReRanking": true,
                    "reRankingApplyFilter": [
                      []
                    ]
                  },
                  "model": "bought-together",
                  "objectID": "test-record-123",
                  "fallbackParameters": {
                    "similarQuery": "comedy drama crime Macy Buscemi",
                    "filters": "(category:Book OR category:Ebook) AND _tags:published",
                    "facetFilters": [
                      [
                        "category:Book",
                        "category:-Movie"
                      ],
                      "author:John Doe"
                    ],
                    "optionalFilters": [
                      "category:Book",
                      "author:John Doe"
                    ],
                    "numericFilters": [
                      [
                        "inStock = 1",
                        "deliveryDate < 1441755506"
                      ],
                      "price < 1000"
                    ],
                    "tagFilters": [
                      [
                        "Book",
                        "Movie"
                      ],
                      "SciFi"
                    ],
                    "sumOrFiltersScores": false,
                    "restrictSearchableAttributes": [
                      "title",
                      "author"
                    ],
                    "facets": [
                      "*"
                    ],
                    "facetingAfterDistinct": false,
                    "aroundLatLng": "40.71,-74.01",
                    "aroundLatLngViaIP": false,
                    "aroundRadius": 1,
                    "aroundPrecision": 10,
                    "minimumAroundRadius": 1,
                    "insideBoundingBox": "lorem",
                    "insidePolygon": [
                      [
                        47.3165,
                        4.9665,
                        47.3424,
                        5.0201,
                        47.32,
                        4.9
                      ],
                      [
                        40.9234,
                        2.1185,
                        38.643,
                        1.9916,
                        39.2587,
                        2.0104
                      ]
                    ],
                    "naturalLanguages": [],
                    "ruleContexts": [
                      "mobile"
                    ],
                    "personalizationImpact": 100,
                    "userToken": "test-user-123",
                    "getRankingInfo": false,
                    "synonyms": true,
                    "clickAnalytics": false,
                    "analytics": true,
                    "analyticsTags": [],
                    "percentileComputation": true,
                    "enableABTest": true,
                    "query": "",
                    "attributesForFaceting": [
                      "author",
                      "filterOnly(isbn)",
                      "searchable(edition)",
                      "afterDistinct(category)",
                      "afterDistinct(searchable(publisher))"
                    ],
                    "replicas": [
                      "virtual(prod_products_price_asc)",
                      "dev_products_replica"
                    ],
                    "paginationLimitedTo": 100,
                    "unretrievableAttributes": [
                      "total_sales"
                    ],
                    "disableTypoToleranceOnWords": [
                      "wheel",
                      "1X2BCD"
                    ],
                    "attributesToTransliterate": [
                      "name",
                      "description"
                    ],
                    "camelCaseAttributes": [
                      "description"
                    ],
                    "decompoundedAttributes": {
                      "de": [
                        "name"
                      ]
                    },
                    "indexLanguages": [
                      "ja"
                    ],
                    "disablePrefixOnAttributes": [
                      "sku"
                    ],
                    "allowCompressionOfIntegerArray": false,
                    "numericAttributesForFiltering": [
                      "equalOnly(quantity)",
                      "popularity"
                    ],
                    "separatorsToIndex": "+#",
                    "searchableAttributes": [
                      "title,alternative_title",
                      "author",
                      "unordered(text)",
                      "emails.personal"
                    ],
                    "userData": {
                      "settingID": "f2a7b51e3503acc6a39b3784ffb84300",
                      "pluginVersion": "1.6.0"
                    },
                    "customNormalization": {
                      "default": {
                        "ä": "ae",
                        "ü": "ue"
                      }
                    },
                    "attributeForDistinct": "url",
                    "maxFacetHits": 10,
                    "keepDiacriticsOnCharacters": "øé",
                    "customRanking": [
                      "desc(popularity)",
                      "asc(price)"
                    ],
                    "attributesToRetrieve": [
                      "author",
                      "title",
                      "content"
                    ],
                    "ranking": [
                      "typo",
                      "geo",
                      "words",
                      "filters",
                      "proximity",
                      "attribute",
                      "exact",
                      "custom"
                    ],
                    "relevancyStrictness": 90,
                    "attributesToHighlight": [
                      "author",
                      "title",
                      "conten",
                      "content"
                    ],
                    "attributesToSnippet": [
                      "content:80",
                      "description"
                    ],
                    "highlightPreTag": "<em>",
                    "highlightPostTag": "</em>",
                    "snippetEllipsisText": "…",
                    "restrictHighlightAndSnippetArrays": false,
                    "minWordSizefor1Typo": 4,
                    "minWordSizefor2Typos": 8,
                    "typoTolerance": true,
                    "allowTyposOnNumericTokens": true,
                    "disableTypoToleranceOnAttributes": [
                      "sku"
                    ],
                    "ignorePlurals": [
                      "ca",
                      "es"
                    ],
                    "removeStopWords": [
                      "ca",
                      "es"
                    ],
                    "queryLanguages": [
                      "es"
                    ],
                    "decompoundQuery": true,
                    "enableRules": true,
                    "enablePersonalization": false,
                    "queryType": "prefixLast",
                    "removeWordsIfNoResults": "firstWords",
                    "advancedSyntax": false,
                    "optionalWords": "lorem",
                    "disableExactOnAttributes": [
                      "description"
                    ],
                    "exactOnSingleWordQuery": "attribute",
                    "alternativesAsExact": [
                      "ignorePlurals",
                      "singleWordSynonym"
                    ],
                    "advancedSyntaxFeatures": [
                      "exactPhrase",
                      "excludeWords"
                    ],
                    "distinct": 1,
                    "replaceSynonymsInHighlight": false,
                    "minProximity": 1,
                    "responseFields": [
                      "*"
                    ],
                    "maxValuesPerFacet": 100,
                    "sortFacetValuesBy": "count",
                    "attributeCriteriaComputedByMinProximity": false,
                    "renderingContent": {
                      "facetOrdering": {
                        "facets": {
                          "order": [
                            "lorem"
                          ]
                        },
                        "values": {
                          "property1": {
                            "order": [
                              "lorem"
                            ],
                            "sortRemainingBy": "count",
                            "hide": [
                              "lorem"
                            ]
                          },
                          "property2": {
                            "order": [
                              "lorem"
                            ],
                            "sortRemainingBy": "count",
                            "hide": [
                              "lorem"
                            ]
                          }
                        }
                      },
                      "redirect": {
                        "url": "lorem"
                      },
                      "widgets": {
                        "banners": [
                          {
                            "image": {
                              "urls": [
                                {
                                  "url": "lorem"
                                }
                              ],
                              "title": "lorem"
                            },
                            "link": {
                              "url": "lorem"
                            }
                          }
                        ]
                      }
                    },
                    "enableReRanking": true,
                    "reRankingApplyFilter": [
                      []
                    ]
                  }
                }
              ]
            }
            '
components:
  schemas:
    recommendationsRequest:
      oneOf:
        - $ref: '#/components/schemas/boughtTogetherQuery'
        - $ref: '#/components/schemas/relatedQuery'
        - $ref: '#/components/schemas/trendingItemsQuery'
        - $ref: '#/components/schemas/trendingFacetsQuery'
        - $ref: '#/components/schemas/lookingSimilarQuery'
    recommendationsResults:
      allOf:
        - $ref: '#/components/schemas/baseSearchResponse'
        - $ref: '#/components/schemas/SearchPagination'
        - $ref: '#/components/schemas/recommendationsHits'
    boughtTogetherQuery:
      type: object
      properties:
        indexName:
          $ref: '#/components/schemas/indexName'
        model:
          $ref: '#/components/schemas/fbtModel'
        objectID:
          $ref: '#/components/schemas/objectID'
        threshold:
          type: number
          format: double
          minimum: 0
          maximum: 100
          description: >-
            Minimum score a recommendation must have to be included in the
            response.
        fallbackParameters:
          $ref: '#/components/schemas/fallbackParams'
        maxRecommendations:
          type: integer
          minimum: 1
          maximum: 30
          default: 30
          description: >
            Maximum number of recommendations to retrieve.

            By default, all recommendations are returned and no fallback request
            is made.

            Depending on the available recommendations and the other request
            parameters,

            the actual number of recommendations may be lower than this value.
        queryParameters:
          $ref: '#/components/schemas/recommendSearchParams'
      required:
        - indexName
        - threshold
        - model
        - objectID
      additionalProperties: false
      title: Frequently bought together
    relatedQuery:
      type: object
      properties:
        indexName:
          $ref: '#/components/schemas/indexName'
        model:
          $ref: '#/components/schemas/relatedModel'
        objectID:
          $ref: '#/components/schemas/objectID'
        threshold:
          type: number
          format: double
          minimum: 0
          maximum: 100
          description: >-
            Minimum score a recommendation must have to be included in the
            response.
        fallbackParameters:
          $ref: '#/components/schemas/fallbackParams'
        maxRecommendations:
          type: integer
          minimum: 1
          maximum: 30
          default: 30
          description: >
            Maximum number of recommendations to retrieve.

            By default, all recommendations are returned and no fallback request
            is made.

            Depending on the available recommendations and the other request
            parameters,

            the actual number of recommendations may be lower than this value.
        queryParameters:
          $ref: '#/components/schemas/recommendSearchParams'
      required:
        - indexName
        - threshold
        - model
        - objectID
      additionalProperties: false
      title: Related products
    trendingItemsQuery:
      type: object
      properties:
        indexName:
          $ref: '#/components/schemas/indexName'
        model:
          $ref: '#/components/schemas/trendingItemsModel'
        threshold:
          type: number
          format: double
          minimum: 0
          maximum: 100
          description: >-
            Minimum score a recommendation must have to be included in the
            response.
        facetName:
          $ref: '#/components/schemas/facetName'
        facetValue:
          $ref: '#/components/schemas/facetValue'
        fallbackParameters:
          $ref: '#/components/schemas/fallbackParams'
        maxRecommendations:
          type: integer
          minimum: 1
          maximum: 30
          default: 30
          description: >
            Maximum number of recommendations to retrieve.

            By default, all recommendations are returned and no fallback request
            is made.

            Depending on the available recommendations and the other request
            parameters,

            the actual number of recommendations may be lower than this value.
        queryParameters:
          $ref: '#/components/schemas/recommendSearchParams'
      required:
        - indexName
        - threshold
        - model
      additionalProperties: false
      title: Trending items
    trendingFacetsQuery:
      type: object
      properties:
        facetName:
          type: string
          description: Facet attribute for which to retrieve trending facet values.
        indexName:
          $ref: '#/components/schemas/indexName'
        model:
          $ref: '#/components/schemas/trendingFacetsModel'
        threshold:
          type: number
          format: double
          minimum: 0
          maximum: 100
          description: >-
            Minimum score a recommendation must have to be included in the
            response.
        maxRecommendations:
          type: integer
          minimum: 1
          maximum: 30
          default: 30
          description: >
            Maximum number of recommendations to retrieve.

            By default, all recommendations are returned and no fallback request
            is made.

            Depending on the available recommendations and the other request
            parameters,

            the actual number of recommendations may be lower than this value.
      required:
        - indexName
        - threshold
        - facetName
        - model
      additionalProperties: false
      title: Trending facet values
    lookingSimilarQuery:
      type: object
      properties:
        indexName:
          $ref: '#/components/schemas/indexName'
        model:
          $ref: '#/components/schemas/lookingSimilarModel'
        objectID:
          $ref: '#/components/schemas/objectID'
        threshold:
          type: number
          format: double
          minimum: 0
          maximum: 100
          description: >-
            Minimum score a recommendation must have to be included in the
            response.
        fallbackParameters:
          $ref: '#/components/schemas/fallbackParams'
        maxRecommendations:
          type: integer
          minimum: 1
          maximum: 30
          default: 30
          description: >
            Maximum number of recommendations to retrieve.

            By default, all recommendations are returned and no fallback request
            is made.

            Depending on the available recommendations and the other request
            parameters,

            the actual number of recommendations may be lower than this value.
        queryParameters:
          $ref: '#/components/schemas/recommendSearchParams'
      required:
        - indexName
        - threshold
        - model
        - objectID
      additionalProperties: false
      title: Looking similar
    baseSearchResponse:
      type: object
      additionalProperties: true
      properties:
        _automaticInsights:
          type: boolean
          description: Whether automatic events collection is enabled for the application.
        abTestID:
          type: integer
          description: >-
            A/B test ID. This is only included in the response for indices that
            are part of an A/B test.
        abTestVariantID:
          type: integer
          minimum: 1
          description: >-
            Variant ID. This is only included in the response for indices that
            are part of an A/B test.
        appliedRules:
          description: Rules applied to the query.
          title: appliedRules
          type: array
          items:
            type: object
        aroundLatLng:
          type: string
          description: Computed geographical location.
          example: 40.71,-74.01
          pattern: ^(-?\d+(\.\d+)?),\s*(-?\d+(\.\d+)?)$
        automaticRadius:
          type: string
          description: Distance from a central coordinate provided by `aroundLatLng`.
        exhaustive:
          title: exhaustive
          type: object
          description: >-
            Whether certain properties of the search response are calculated
            exhaustive (exact) or approximated.
          properties:
            facetsCount:
              type: boolean
              title: facetsCount
              description: >-
                Whether the facet count is exhaustive (`true`) or approximate
                (`false`). See the [related
                discussion](https://support.algolia.com/hc/articles/4406975248145-Why-are-my-facet-and-hit-counts-not-accurate).
            facetValues:
              type: boolean
              title: facetValues
              description: The value is `false` if not all facet values are retrieved.
            nbHits:
              type: boolean
              title: nbHits
              description: >-
                Whether the `nbHits` is exhaustive (`true`) or approximate
                (`false`). When the query takes more than 50ms to be processed,
                the engine makes an approximation. This can happen when using
                complex filters on millions of records, when typo-tolerance was
                not exhaustive, or when enough hits have been retrieved (for
                example, after the engine finds 10,000 exact matches). `nbHits`
                is reported as non-exhaustive whenever an approximation is made,
                even if the approximation didn’t, in the end, impact the
                exhaustivity of the query.
            rulesMatch:
              type: boolean
              title: rulesMatch
              description: >-
                Rules matching exhaustivity. The value is `false` if rules were
                enable for this query, and could not be fully processed due a
                timeout. This is generally caused by the number of alternatives
                (such as typos) which is too large.
            typo:
              type: boolean
              title: typo
              description: >-
                Whether the typo search was exhaustive (`true`) or approximate
                (`false`). An approximation is done when the typo search query
                part takes more than 10% of the query budget (ie. 5ms by
                default) to be processed (this can happen when a lot of typo
                alternatives exist for the query). This field will not be
                included when typo-tolerance is entirely disabled.
        exhaustiveFacetsCount:
          type: boolean
          description: >-
            See the `facetsCount` field of the `exhaustive` object in the
            response.
          deprecated: true
        exhaustiveNbHits:
          type: boolean
          description: See the `nbHits` field of the `exhaustive` object in the response.
          deprecated: true
        exhaustiveTypo:
          type: boolean
          description: See the `typo` field of the `exhaustive` object in the response.
          deprecated: true
        facets:
          title: facets
          type: object
          additionalProperties:
            x-additionalPropertiesName: facet
            type: object
            additionalProperties:
              x-additionalPropertiesName: facet count
              type: integer
          description: Facet counts.
          example:
            category:
              food: 1
              tech: 42
        facets_stats:
          type: object
          description: Statistics for numerical facets.
          additionalProperties:
            title: facetStats
            type: object
            properties:
              avg:
                type: number
                format: double
                description: Average facet value in the results.
              max:
                type: number
                format: double
                description: Maximum value in the results.
              min:
                type: number
                format: double
                description: Minimum value in the results.
              sum:
                type: number
                format: double
                description: Sum of all values in the results.
        index:
          type: string
          example: indexName
          description: Index name used for the query.
        indexUsed:
          type: string
          description: >-
            Index name used for the query. During A/B testing, the targeted
            index isn't always the index used by the query.
          example: indexNameAlt
        message:
          type: string
          description: Warnings about the query.
        nbSortedHits:
          type: integer
          description: Number of hits selected and sorted by the relevant sort algorithm.
          example: 20
        parsedQuery:
          type: string
          description: >-
            Post-[normalization](https://www.algolia.com/doc/guides/managing-results/optimize-search-results/handling-natural-languages-nlp/#what-does-normalization-mean)
            query string that will be searched.
          example: george clo
        processingTimeMS:
          $ref: '#/components/schemas/processingTimeMS'
        processingTimingsMS:
          type: object
          description: >-
            Experimental. List of processing steps and their times, in
            milliseconds. You can use this list to investigate performance
            issues.
        queryAfterRemoval:
          type: string
          description: >-
            Markup text indicating which parts of the original query have been
            removed to retrieve a non-empty result set.
        queryID:
          type: string
          description: >-
            Unique identifier for the query. This is used for [click
            analytics](https://www.algolia.com/doc/guides/analytics/click-analytics).
          example: a00dbc80a8d13c4565a442e7e2dca80a
        redirect:
          title: redirect
          type: object
          description: >
            [Redirect results to a
            URL](https://www.algolia.com/doc/guides/managing-results/rules/merchandising-and-promoting/how-to/redirects),
            this this parameter is for internal use only.
          properties:
            index:
              type: array
              items:
                $ref: '#/components/schemas/RedirectRuleIndexMetadata'
        renderingContent:
          $ref: '#/components/schemas/renderingContent'
        serverTimeMS:
          type: integer
          description: Time the server took to process the request, in milliseconds.
          example: 20
        serverUsed:
          type: string
          description: Host name of the server that processed the request.
          example: c2-uk-3.algolia.net
        userData:
          $ref: '#/components/schemas/userData'
    SearchPagination:
      type: object
      additionalProperties: false
      properties:
        hitsPerPage:
          $ref: '#/components/schemas/hitsPerPage'
        nbHits:
          $ref: '#/components/schemas/nbHits'
        nbPages:
          $ref: '#/components/schemas/nbPages'
        page:
          $ref: '#/components/schemas/page'
    recommendationsHits:
      type: object
      additionalProperties: false
      properties:
        hits:
          type: array
          items:
            $ref: '#/components/schemas/recommendationsHit'
      required:
        - hits
    ErrorBase:
      description: Error.
      type: object
      x-keep-model: true
      additionalProperties: true
      properties:
        message:
          type: string
          example: Invalid Application-Id or API-Key
    indexName:
      type: string
      example: products
      description: Index name (case-sensitive).
    fbtModel:
      type: string
      description: >
        Frequently bought together model.


        This model recommends items that have been purchased within 1 day with
        the item with the ID `objectID`.
      enum:
        - bought-together
    objectID:
      type: string
      description: Unique record identifier.
      example: test-record-123
    fallbackParams:
      title: fallbackParameters
      allOf:
        - $ref: '#/components/schemas/recommendSearchParams'
        - type: object
          description: >-
            Search parameters to use for a fallback request if there aren't
            enough recommendations.
    recommendSearchParams:
      title: Search parameters as object
      description: Search parameters for filtering the recommendations.
      allOf:
        - $ref: '#/components/schemas/baseRecommendSearchParams'
        - $ref: '#/components/schemas/searchParamsQuery'
        - $ref: '#/components/schemas/recommendIndexSettings'
    relatedModel:
      type: string
      description: >
        Related products or similar content model.


        This model recommends items that are similar to the item with the ID
        `objectID`.

        Similarity is determined from the user interactions and attributes.
      enum:
        - related-products
    trendingItemsModel:
      description: >
        Trending items model.


        Trending items are determined from the number of conversion events
        collected on them.
      type: string
      enum:
        - trending-items
    facetName:
      type: string
      description: >
        Facet attribute. To be used in combination with `facetValue`.

        If specified, only recommendations matching the facet filter will be
        returned.
    facetValue:
      type: string
      description: >
        Facet value. To be used in combination with `facetName`.

        If specified, only recommendations matching the facet filter will be
        returned.
    trendingFacetsModel:
      type: string
      description: >
        Trending facet values model.


        This model recommends trending facet values for the specified facet
        attribute.
      enum:
        - trending-facets
    lookingSimilarModel:
      type: string
      description: >
        Looking similar model.


        This model recommends items that look similar to the item with the ID
        `objectID` based on image attributes in your index.
      enum:
        - looking-similar
    processingTimeMS:
      type: integer
      description: Time the server took to process the request, in milliseconds.
      example: 20
    RedirectRuleIndexMetadata:
      type: object
      properties:
        data:
          title: redirectRuleIndexData
          type: object
          description: Redirect rule data.
          required:
            - ruleObjectID
          properties:
            ruleObjectID:
              type: string
        dest:
          type: string
          description: Destination index for the redirect rule.
        reason:
          type: string
          description: Reason for the redirect rule.
        source:
          type: string
          description: Source index for the redirect rule.
        succeed:
          type: boolean
          description: Redirect rule status.
      required:
        - data
        - succeed
        - reason
        - dest
        - source
    renderingContent:
      description: >
        Extra data that can be used in the search UI.


        You can use this to control aspects of your search UI, such as the order
        of facet names and values

        without changing your frontend code.
      type: object
      additionalProperties: false
      properties:
        facetOrdering:
          $ref: '#/components/schemas/facetOrdering'
        redirect:
          $ref: '#/components/schemas/redirectURL'
        widgets:
          $ref: '#/components/schemas/widgets'
      x-categories:
        - Advanced
    userData:
      example:
        settingID: f2a7b51e3503acc6a39b3784ffb84300
        pluginVersion: 1.6.0
      description: |
        An object with custom data.

        You can store up to 32kB as custom data.
      default: {}
      x-categories:
        - Advanced
    hitsPerPage:
      type: integer
      description: Number of hits per page.
      default: 20
      minimum: 1
      maximum: 1000
      x-categories:
        - Pagination
    nbHits:
      type: integer
      description: Number of results (hits).
      example: 20
    nbPages:
      type: integer
      description: Number of pages of results.
      example: 1
    page:
      type: integer
      description: Page of search results to retrieve.
      default: 0
      minimum: 0
      x-categories:
        - Pagination
    recommendationsHit:
      oneOf:
        - $ref: '#/components/schemas/recommendHit'
        - $ref: '#/components/schemas/trendingFacetHit'
    baseRecommendSearchParams:
      type: object
      additionalProperties: false
      properties:
        analytics:
          $ref: '#/components/schemas/analytics'
        analyticsTags:
          $ref: '#/components/schemas/analyticsTags'
        aroundLatLng:
          $ref: '#/components/schemas/aroundLatLng'
        aroundLatLngViaIP:
          $ref: '#/components/schemas/aroundLatLngViaIP'
        aroundPrecision:
          $ref: '#/components/schemas/aroundPrecision'
        aroundRadius:
          $ref: '#/components/schemas/aroundRadius'
        clickAnalytics:
          $ref: '#/components/schemas/clickAnalytics'
        enableABTest:
          $ref: '#/components/schemas/enableABTest'
        facetFilters:
          $ref: '#/components/schemas/facetFilters'
        facetingAfterDistinct:
          $ref: '#/components/schemas/facetingAfterDistinct'
        facets:
          $ref: '#/components/schemas/facets'
        filters:
          $ref: '#/components/schemas/filters'
        getRankingInfo:
          $ref: '#/components/schemas/getRankingInfo'
        insideBoundingBox:
          $ref: '#/components/schemas/insideBoundingBox'
        insidePolygon:
          $ref: '#/components/schemas/insidePolygon'
        minimumAroundRadius:
          $ref: '#/components/schemas/minimumAroundRadius'
        naturalLanguages:
          $ref: '#/components/schemas/naturalLanguages'
        numericFilters:
          $ref: '#/components/schemas/numericFilters'
        optionalFilters:
          $ref: '#/components/schemas/optionalFilters'
        percentileComputation:
          $ref: '#/components/schemas/percentileComputation'
        personalizationImpact:
          $ref: '#/components/schemas/personalizationImpact'
        restrictSearchableAttributes:
          $ref: '#/components/schemas/restrictSearchableAttributes'
        ruleContexts:
          $ref: '#/components/schemas/ruleContexts'
        similarQuery:
          $ref: '#/components/schemas/similarQuery'
        sumOrFiltersScores:
          $ref: '#/components/schemas/sumOrFiltersScores'
        synonyms:
          $ref: '#/components/schemas/synonyms'
        tagFilters:
          $ref: '#/components/schemas/tagFilters'
        userToken:
          $ref: '#/components/schemas/userToken'
    searchParamsQuery:
      type: object
      additionalProperties: false
      properties:
        query:
          $ref: '#/components/schemas/query'
    recommendIndexSettings:
      type: object
      properties:
        advancedSyntax:
          $ref: '#/components/schemas/advancedSyntax'
        advancedSyntaxFeatures:
          $ref: '#/components/schemas/IndexSettings_advancedSyntaxFeatures'
        allowCompressionOfIntegerArray:
          type: boolean
          description: >
            Whether arrays with exclusively non-negative integers should be
            compressed for better performance.

            If true, the compressed arrays may be reordered.
          default: false
          x-categories:
            - Performance
        allowTyposOnNumericTokens:
          $ref: '#/components/schemas/allowTyposOnNumericTokens'
        alternativesAsExact:
          $ref: '#/components/schemas/IndexSettings_alternativesAsExact'
        attributeCriteriaComputedByMinProximity:
          $ref: '#/components/schemas/attributeCriteriaComputedByMinProximity'
        attributeForDistinct:
          description: >
            Attribute that should be used to establish groups of results.

            Attribute names are case-sensitive.


            All records with the same value for this attribute are considered a
            group.

            You can combine `attributeForDistinct` with the `distinct` search
            parameter to control

            how many items per group are included in the search results.


            If you want to use the same attribute also for faceting, use the
            `afterDistinct` modifier of the `attributesForFaceting` setting.

            This applies faceting _after_ deduplication, which will result in
            accurate facet counts.
          example: url
          type: string
        attributesForFaceting:
          type: array
          items:
            type: string
          example:
            - author
            - filterOnly(isbn)
            - searchable(edition)
            - afterDistinct(category)
            - afterDistinct(searchable(publisher))
          description: >
            Attributes used for
            [faceting](https://www.algolia.com/doc/guides/managing-results/refine-results/faceting).


            Facets are attributes that let you categorize search results.

            They can be used for filtering search results.

            By default, no attribute is used for faceting.

            Attribute names are case-sensitive.


            **Modifiers**


            - `filterOnly("ATTRIBUTE")`.
              Allows the attribute to be used as a filter but doesn't evaluate the facet values.

            - `searchable("ATTRIBUTE")`.
              Allows searching for facet values.

            - `afterDistinct("ATTRIBUTE")`.
              Evaluates the facet count _after_ deduplication with `distinct`.
              This ensures accurate facet counts.
              You can apply this modifier to searchable facets: `afterDistinct(searchable(ATTRIBUTE))`.
          default: []
          x-categories:
            - Faceting
        attributesToHighlight:
          $ref: '#/components/schemas/attributesToHighlight'
        attributesToRetrieve:
          $ref: '#/components/schemas/attributesToRetrieve'
        attributesToSnippet:
          $ref: '#/components/schemas/attributesToSnippet'
        attributesToTransliterate:
          description: >
            Attributes, for which you want to support [Japanese
            transliteration](https://www.algolia.com/doc/guides/managing-results/optimize-search-results/handling-natural-languages-nlp/in-depth/language-specific-configurations/#japanese-transliteration-and-type-ahead).


            Transliteration supports searching in any of the Japanese writing
            systems.

            To support transliteration, you must set the indexing language to
            Japanese.

            Attribute names are case-sensitive.
          type: array
          items:
            type: string
          example:
            - name
            - description
          x-categories:
            - Languages
        camelCaseAttributes:
          type: array
          items:
            type: string
          example:
            - description
          description: >
            Attributes for which to split [camel
            case](https://wikipedia.org/wiki/Camel_case) words.

            Attribute names are case-sensitive.
          default: []
          x-categories:
            - Languages
        customNormalization:
          description: >
            Characters and their normalized replacements.

            This overrides Algolia's default
            [normalization](https://www.algolia.com/doc/guides/managing-results/optimize-search-results/handling-natural-languages-nlp/in-depth/normalization).
          type: object
          example:
            default:
              ä: ae
              ü: ue
          additionalProperties:
            type: object
            additionalProperties:
              type: string
          x-categories:
            - Languages
        customRanking:
          type: array
          items:
            type: string
          example:
            - desc(popularity)
            - asc(price)
          description: >
            Attributes to use as [custom
            ranking](https://www.algolia.com/doc/guides/managing-results/must-do/custom-ranking).

            Attribute names are case-sensitive.


            The custom ranking attributes decide which items are shown first if
            the other ranking criteria are equal.


            Records with missing values for your selected custom ranking
            attributes are always sorted last.

            Boolean attributes are sorted based on their alphabetical order.


            **Modifiers**


            - `asc("ATTRIBUTE")`.
              Sort the index by the values of an attribute, in ascending order.

            - `desc("ATTRIBUTE")`.
              Sort the index by the values of an attribute, in descending order.

            If you use two or more custom ranking attributes,

            [reduce the
            precision](https://www.algolia.com/doc/guides/managing-results/must-do/custom-ranking/how-to/controlling-custom-ranking-metrics-precision)
            of your first attributes,

            or the other attributes will never be applied.
          default: []
          x-categories:
            - Ranking
        decompoundedAttributes:
          type: object
          example:
            de:
              - name
          description: >
            Searchable attributes to which Algolia should apply [word
            segmentation](https://www.algolia.com/doc/guides/managing-results/optimize-search-results/handling-natural-languages-nlp/how-to/customize-segmentation)
            (decompounding).

            Attribute names are case-sensitive.


            Compound words are formed by combining two or more individual words,

            and are particularly prevalent in Germanic languages—for example,
            "firefighter".

            With decompounding, the individual components are indexed
            separately.


            You can specify different lists for different languages.

            Decompounding is supported for these languages:

            Dutch (`nl`), German (`de`), Finnish (`fi`), Danish (`da`), Swedish
            (`sv`), and Norwegian (`no`).

            Decompounding doesn't work for words with [non-spacing mark Unicode
            characters](https://www.charactercodes.net/category/non-spacing_mark).

            For example, `Gartenstühle` won't be decompounded if the `ü`
            consists of `u` (U+0075) and `◌̈` (U+0308).
          default: {}
          x-categories:
            - Languages
        decompoundQuery:
          $ref: '#/components/schemas/decompoundQuery'
        disableExactOnAttributes:
          $ref: '#/components/schemas/disableExactOnAttributes'
        disablePrefixOnAttributes:
          type: array
          items:
            type: string
          example:
            - sku
          description: >
            Searchable attributes for which you want to turn off [prefix
            matching](https://www.algolia.com/doc/guides/managing-results/optimize-search-results/override-search-engine-defaults/#adjusting-prefix-search).

            Attribute names are case-sensitive.
          default: []
          x-categories:
            - Query strategy
        disableTypoToleranceOnAttributes:
          $ref: '#/components/schemas/disableTypoToleranceOnAttributes'
        disableTypoToleranceOnWords:
          type: array
          items:
            type: string
          example:
            - wheel
            - 1X2BCD
          description: >
            Creates a list of [words which require exact
            matches](https://www.algolia.com/doc/guides/managing-results/optimize-search-results/typo-tolerance/in-depth/configuring-typo-tolerance/#turn-off-typo-tolerance-for-certain-words).

            This also turns off [word splitting and
            concatenation](https://www.algolia.com/doc/guides/managing-results/optimize-search-results/handling-natural-languages-nlp/in-depth/splitting-and-concatenation)
            for the specified words.
          default: []
          x-categories:
            - Typos
        distinct:
          $ref: '#/components/schemas/distinct'
        enablePersonalization:
          $ref: '#/components/schemas/enablePersonalization'
        enableReRanking:
          $ref: '#/components/schemas/enableReRanking'
        enableRules:
          $ref: '#/components/schemas/enableRules'
        exactOnSingleWordQuery:
          $ref: '#/components/schemas/exactOnSingleWordQuery'
        highlightPostTag:
          $ref: '#/components/schemas/highlightPostTag'
        highlightPreTag:
          $ref: '#/components/schemas/highlightPreTag'
        ignorePlurals:
          $ref: '#/components/schemas/ignorePlurals'
        indexLanguages:
          type: array
          items:
            $ref: '#/components/schemas/supportedLanguage'
          example:
            - ja
          description: >
            Languages for language-specific processing steps, such as word
            detection and dictionary settings.


            **Always specify an indexing language.**

            If you don't specify an indexing language, the search engine uses
            all [supported
            languages](https://www.algolia.com/doc/guides/managing-results/optimize-search-results/handling-natural-languages-nlp/in-depth/supported-languages),

            or the languages you specified with the `ignorePlurals` or
            `removeStopWords` parameters.

            This can lead to unexpected search results.

            For more information, see [Language-specific
            configuration](https://www.algolia.com/doc/guides/managing-results/optimize-search-results/handling-natural-languages-nlp/in-depth/language-specific-configurations).
          default: []
          x-categories:
            - Languages
        keepDiacriticsOnCharacters:
          type: string
          example: øé
          description: |
            Characters for which diacritics should be preserved.

            By default, Algolia removes diacritics from letters.
            For example, `é` becomes `e`. If this causes issues in your search,
            you can specify characters that should keep their diacritics.
          default: ''
          x-categories:
            - Languages
        maxFacetHits:
          $ref: '#/components/schemas/maxFacetHits'
        maxValuesPerFacet:
          $ref: '#/components/schemas/maxValuesPerFacet'
        minProximity:
          $ref: '#/components/schemas/minProximity'
        minWordSizefor1Typo:
          $ref: '#/components/schemas/minWordSizefor1Typo'
        minWordSizefor2Typos:
          $ref: '#/components/schemas/minWordSizefor2Typos'
        numericAttributesForFiltering:
          type: array
          items:
            type: string
          description: >
            Numeric attributes that can be used as [numerical
            filters](https://www.algolia.com/doc/guides/managing-results/rules/detecting-intent/how-to/applying-a-custom-filter-for-a-specific-query/#numerical-filters).

            Attribute names are case-sensitive.


            By default, all numeric attributes are available as numerical
            filters.

            For faster indexing, reduce the number of numeric attributes.


            To turn off filtering for all numeric attributes, specify an
            attribute that doesn't exist in your index, such as
            `NO_NUMERIC_FILTERING`.


            **Modifier**


            - `equalOnly("ATTRIBUTE")`.
              Support only filtering based on equality comparisons `=` and `!=`.
          example:
            - equalOnly(quantity)
            - popularity
          default: []
          x-categories:
            - Performance
        optionalWords:
          $ref: '#/components/schemas/optionalWords'
        paginationLimitedTo:
          type: integer
          example: 100
          description: >
            Maximum number of search results that can be obtained through
            pagination.


            Higher pagination limits might slow down your search.

            For pagination limits above 1,000, the sorting of results beyond the
            1,000th hit can't be guaranteed.
          default: 1000
          maximum: 20000
        queryLanguages:
          $ref: '#/components/schemas/queryLanguages'
        queryType:
          $ref: '#/components/schemas/queryType'
        ranking:
          $ref: '#/components/schemas/ranking'
        relevancyStrictness:
          $ref: '#/components/schemas/relevancyStrictness'
        removeStopWords:
          $ref: '#/components/schemas/removeStopWords'
        removeWordsIfNoResults:
          $ref: '#/components/schemas/removeWordsIfNoResults'
        renderingContent:
          $ref: '#/components/schemas/renderingContent'
        replaceSynonymsInHighlight:
          $ref: '#/components/schemas/replaceSynonymsInHighlight'
        replicas:
          type: array
          items:
            type: string
          example:
            - virtual(prod_products_price_asc)
            - dev_products_replica
          description: >
            Creates [replica
            indices](https://www.algolia.com/doc/guides/managing-results/refine-results/sorting/in-depth/replicas).


            Replicas are copies of a primary index with the same records but
            different settings, synonyms, or rules.

            If you want to offer a different ranking or sorting of your search
            results, you'll use replica indices.

            All index operations on a primary index are automatically forwarded
            to its replicas.

            To add a replica index, you must provide the complete set of
            replicas to this parameter.

            If you omit a replica from this list, the replica turns into a
            regular, standalone index that will no longer be synced with the
            primary index.


            **Modifier**


            - `virtual("REPLICA")`.
              Create a virtual replica,
              Virtual replicas don't increase the number of records and are optimized for [Relevant sorting](https://www.algolia.com/doc/guides/managing-results/refine-results/sorting/in-depth/relevant-sort).
          default: []
          x-categories:
            - Ranking
        reRankingApplyFilter:
          oneOf:
            - $ref: '#/components/schemas/reRankingApplyFilter'
            - type: 'null'
        responseFields:
          $ref: '#/components/schemas/responseFields'
        restrictHighlightAndSnippetArrays:
          $ref: '#/components/schemas/restrictHighlightAndSnippetArrays'
        searchableAttributes:
          type: array
          items:
            type: string
          example:
            - title,alternative_title
            - author
            - unordered(text)
            - emails.personal
          description: >
            Attributes used for searching. Attribute names are case-sensitive.


            By default, all attributes are searchable and the
            [Attribute](https://www.algolia.com/doc/guides/managing-results/relevance-overview/in-depth/ranking-criteria/#attribute)
            ranking criterion is turned off.

            With a non-empty list, Algolia only returns results with matches in
            the selected attributes.

            In addition, the Attribute ranking criterion is turned on: matches
            in attributes that are higher in the list of `searchableAttributes`
            rank first.

            To make matches in two attributes rank equally, include them in a
            comma-separated string, such as `"title,alternate_title"`.

            Attributes with the same priority are always unordered.


            For more information, see [Searchable
            attributes](https://www.algolia.com/doc/guides/sending-and-managing-data/prepare-your-data/how-to/setting-searchable-attributes).


            **Modifier**


            - `unordered("ATTRIBUTE")`.
              Ignore the position of a match within the attribute.

            Without a modifier, matches at the beginning of an attribute rank
            higher than matches at the end.
          default: []
          x-categories:
            - Attributes
        separatorsToIndex:
          type: string
          example: +#
          description: >
            Control which non-alphanumeric characters are indexed.


            By default, Algolia ignores [non-alphanumeric
            characters](https://www.algolia.com/doc/guides/managing-results/optimize-search-results/typo-tolerance/how-to/how-to-search-in-hyphenated-attributes/#handling-non-alphanumeric-characters)
            like hyphen (`-`), plus (`+`), and parentheses (`(`,`)`).

            To include such characters, define them with `separatorsToIndex`.


            Separators are all non-letter characters except spaces and currency
            characters, such as $€£¥.


            With `separatorsToIndex`, Algolia treats separator characters as
            separate words.

            For example, in a search for "Disney+", Algolia considers "Disney"
            and "+" as two separate words.
          default: ''
          x-categories:
            - Typos
        snippetEllipsisText:
          $ref: '#/components/schemas/snippetEllipsisText'
        sortFacetValuesBy:
          $ref: '#/components/schemas/sortFacetValuesBy'
        typoTolerance:
          $ref: '#/components/schemas/typoTolerance'
        unretrievableAttributes:
          type: array
          items:
            type: string
          example:
            - total_sales
          description: >
            Attributes that can't be retrieved at query time.


            This can be useful if you want to use an attribute for ranking or to
            [restrict
            access](https://www.algolia.com/doc/guides/security/api-keys/how-to/user-restricted-access-to-data),

            but don't want to include it in the search results.

            Attribute names are case-sensitive.
          default: []
          x-categories:
            - Attributes
        userData:
          $ref: '#/components/schemas/userData'
      additionalProperties: false
      description: Index settings.
    facetOrdering:
      description: Order of facet names and facet values in your UI.
      type: object
      additionalProperties: false
      properties:
        facets:
          $ref: '#/components/schemas/IndexSettings_facets'
        values:
          $ref: '#/components/schemas/values'
    redirectURL:
      description: The redirect rule container.
      type: object
      additionalProperties: false
      properties:
        url:
          type: string
    widgets:
      description: Widgets returned from any rules that are applied to the current search.
      type: object
      additionalProperties: false
      properties:
        banners:
          $ref: '#/components/schemas/banners'
    recommendHit:
      type: object
      description: Recommend hit.
      additionalProperties: true
      required:
        - objectID
      properties:
        objectID:
          $ref: '#/components/schemas/objectID'
        _distinctSeqID:
          $ref: '#/components/schemas/distinctSeqID'
        _highlightResult:
          $ref: '#/components/schemas/highlightResultMap'
        _rankingInfo:
          $ref: '#/components/schemas/rankingInfo'
        _score:
          $ref: '#/components/schemas/recommendScore'
        _snippetResult:
          $ref: '#/components/schemas/snippetResultMap'
      x-discriminator-fields:
        - objectID
    trendingFacetHit:
      type: object
      title: Trending facet hit
      description: Trending facet hit.
      required:
        - facetName
        - facetValue
      properties:
        facetName:
          $ref: '#/components/schemas/facetName'
        facetValue:
          $ref: '#/components/schemas/facetValue'
        _score:
          $ref: '#/components/schemas/recommendScore'
      x-discriminator-fields:
        - facetName
        - facetValue
    analytics:
      type: boolean
      description: Whether this search will be included in Analytics.
      default: true
      x-categories:
        - Analytics
    analyticsTags:
      type: array
      items:
        type: string
      description: >-
        Tags to apply to the query for [segmenting analytics
        data](https://www.algolia.com/doc/guides/search-analytics/guides/segments).
      default: []
    aroundLatLng:
      type: string
      description: >
        Coordinates for the center of a circle, expressed as a comma-separated
        string of latitude and longitude.


        Only records included within a circle around this central location are
        included in the results.

        The radius of the circle is determined by the `aroundRadius` and
        `minimumAroundRadius` settings.

        This parameter is ignored if you also specify `insidePolygon` or
        `insideBoundingBox`.
      example: 40.71,-74.01
      default: ''
      x-categories:
        - Geo-Search
    aroundLatLngViaIP:
      type: boolean
      description: Whether to obtain the coordinates from the request's IP address.
      default: false
      x-categories:
        - Geo-Search
    aroundPrecision:
      description: >
        Precision of a coordinate-based search in meters to group results with
        similar distances.


        The Geo ranking criterion considers all matches within the same range of
        distances to be equal.
      oneOf:
        - type: integer
          default: 10
          description: >
            Distance in meters to group results by similar distances.


            For example, if you set `aroundPrecision` to 100, records wihin 100
            meters to the central coordinate are considered to have the same
            distance,

            as are records between 100 and 199 meters.
        - $ref: '#/components/schemas/aroundPrecisionFromValue'
      x-categories:
        - Geo-Search
    aroundRadius:
      description: >
        Maximum radius for a search around a central location.


        This parameter works in combination with the `aroundLatLng` and
        `aroundLatLngViaIP` parameters.

        By default, the search radius is determined automatically from the
        density of hits around the central location.

        The search radius is small if there are many hits close to the central
        coordinates.
      oneOf:
        - type: integer
          minimum: 1
          description: Maximum search radius around a central location in meters.
        - $ref: '#/components/schemas/aroundRadiusAll'
      x-categories:
        - Geo-Search
    clickAnalytics:
      type: boolean
      description: >
        Whether to include a `queryID` attribute in the response

        The query ID is a unique identifier for a search query and is required
        for tracking [click and conversion
        events](https://www.algolia.com/doc/guides/sending-events/getting-started).
      default: false
      x-categories:
        - Analytics
    enableABTest:
      type: boolean
      description: Whether to enable A/B testing for this search.
      default: true
      x-categories:
        - Advanced
    facetFilters:
      description: >
        Filter the search by facet values, so that only records with the same
        facet values are retrieved.


        **Prefer using the `filters` parameter, which supports all filter types
        and combinations with boolean operators.**


        - `[filter1, filter2]` is interpreted as `filter1 AND filter2`.

        - `[[filter1, filter2], filter3]` is interpreted as `filter1 OR filter2
        AND filter3`.

        - `facet:-value` is interpreted as `NOT facet:value`.


        While it's best to avoid attributes that start with a `-`, you can still
        filter them by escaping with a backslash:

        `facet:\-value`.
      example:
        - - category:Book
          - category:-Movie
        - author:John Doe
      oneOf:
        - type: array
          items:
            $ref: '#/components/schemas/facetFilters'
        - type: string
      x-categories:
        - Filtering
    facetingAfterDistinct:
      type: boolean
      description: >
        Whether faceting should be applied after deduplication with `distinct`

        This leads to accurate facet counts when using faceting in combination
        with `distinct`.

        It's usually better to use `afterDistinct` modifiers in the
        `attributesForFaceting` setting,

        as `facetingAfterDistinct` only computes correct facet counts if all
        records have the same facet values for the `attributeForDistinct`.
      default: false
      x-categories:
        - Faceting
    facets:
      type: array
      items:
        type: string
      description: >
        Facets for which to retrieve facet values that match the search criteria
        and the number of matching facet values

        To retrieve all facets, use the wildcard character `*`.

        For more information, see
        [facets](https://www.algolia.com/doc/guides/managing-results/refine-results/faceting/#contextual-facet-values-and-counts).
      default: []
      example:
        - '*'
      x-categories:
        - Faceting
    filters:
      type: string
      description: >
        Filter expression to only include items that match the filter criteria
        in the response.


        You can use these filter expressions:


        - **Numeric filters.** `<facet> <op> <number>`, where `<op>` is one of
        `<`, `<=`, `=`, `!=`, `>`, `>=`.

        - **Ranges.** `<facet>:<lower> TO <upper>`, where `<lower>` and
        `<upper>` are the lower and upper limits of the range (inclusive).

        - **Facet filters.** `<facet>:<value>`, where `<facet>` is a facet
        attribute (case-sensitive) and `<value>` a facet value.

        - **Tag filters.** `_tags:<value>` or just `<value>` (case-sensitive).

        - **Boolean filters.** `<facet>: true | false`.


        You can combine filters with `AND`, `OR`, and `NOT` operators with the
        following restrictions:


        - You can only combine filters of the same type with `OR`.
          **Not supported:** `facet:value OR num > 3`.
        - You can't use `NOT` with combinations of filters.
          **Not supported:** `NOT(facet:value OR facet:value)`
        - You can't combine conjunctions (`AND`) with `OR`.
          **Not supported:** `facet:value OR (facet:value AND facet:value)`

        Use quotes if the facet attribute name or facet value contains spaces,
        keywords (`OR`, `AND`, `NOT`), or quotes.

        If a facet attribute is an array, the filter matches if it matches at
        least one element of the array.


        For more information, see
        [Filters](https://www.algolia.com/doc/guides/managing-results/refine-results/filtering).
      example: (category:Book OR category:Ebook) AND _tags:published
      x-categories:
        - Filtering
    getRankingInfo:
      type: boolean
      description: Whether the search response should include detailed ranking information.
      default: false
      x-categories:
        - Advanced
    insideBoundingBox:
      oneOf:
        - type: string
        - type: 'null'
        - $ref: '#/components/schemas/insideBoundingBoxArray'
    insidePolygon:
      type: array
      items:
        type: array
        minItems: 6
        maxItems: 20000
        items:
          type: number
          format: double
      description: >
        Coordinates of a polygon in which to search.


        Polygons are defined by 3 to 10,000 points. Each point is represented by
        its latitude and longitude.

        Provide multiple polygons as nested arrays.

        For more information, see [filtering inside
        polygons](https://www.algolia.com/doc/guides/managing-results/refine-results/geolocation/#filtering-inside-rectangular-or-polygonal-areas).

        This parameter is ignored if you also specify `insideBoundingBox`.
      example:
        - - 47.3165
          - 4.9665
          - 47.3424
          - 5.0201
          - 47.32
          - 4.9
        - - 40.9234
          - 2.1185
          - 38.643
          - 1.9916
          - 39.2587
          - 2.0104
      x-categories:
        - Geo-Search
    minimumAroundRadius:
      type: integer
      description: >-
        Minimum radius (in meters) for a search around a location when
        `aroundRadius` isn't set.
      minimum: 1
      x-categories:
        - Geo-Search
    naturalLanguages:
      type: array
      items:
        $ref: '#/components/schemas/supportedLanguage'
      description: >
        ISO language codes that adjust settings that are useful for processing
        natural language queries (as opposed to keyword searches)

        - Sets `removeStopWords` and `ignorePlurals` to the list of provided
        languages.

        - Sets `removeWordsIfNoResults` to `allOptional`.

        - Adds a `natural_language` attribute to `ruleContexts` and
        `analyticsTags`.
      default: []
      x-categories:
        - Languages
    numericFilters:
      description: >
        Filter by numeric facets.


        **Prefer using the `filters` parameter, which supports all filter types
        and combinations with boolean operators.**


        You can use numeric comparison operators: `<`, `<=`, `=`, `!=`, `>`,
        `>=`.

        Comparisons are precise up to 3 decimals.

        You can also provide ranges: `facet:<lower> TO <upper>`. The range
        includes the lower and upper boundaries.

        The same combination rules apply as for `facetFilters`.
      example:
        - - inStock = 1
          - deliveryDate < 1441755506
        - price < 1000
      oneOf:
        - type: array
          items:
            $ref: '#/components/schemas/numericFilters'
        - type: string
      x-categories:
        - Filtering
    optionalFilters:
      description: >
        Filters to promote or demote records in the search results.


        Optional filters work like facet filters, but they don't exclude records
        from the search results.

        Records that match the optional filter rank before records that don't
        match.

        If you're using a negative filter `facet:-value`, matching records rank
        after records that don't match.


        - Optional filters are applied _after_ sort-by attributes.

        - Optional filters are applied _before_ custom ranking attributes (in
        the default
        [ranking](https://www.algolia.com/doc/guides/managing-results/relevance-overview/in-depth/ranking-criteria)).

        - Optional filters don't work with numeric attributes.

        - On virtual replicas, optional filters are applied _after_ the
        replica's [relevant
        sort](https://www.algolia.com/doc/guides/managing-results/refine-results/sorting/in-depth/relevant-sort).
      example:
        - category:Book
        - author:John Doe
      oneOf:
        - type: array
          items:
            $ref: '#/components/schemas/optionalFilters'
        - type: string
      x-categories:
        - Filtering
    percentileComputation:
      type: boolean
      description: >-
        Whether to include this search when calculating processing-time
        percentiles.
      default: true
      x-categories:
        - Advanced
    personalizationImpact:
      type: integer
      description: >
        Impact that Personalization should have on this search

        The higher this value is, the more Personalization determines the
        ranking compared to other factors.

        For more information, see [Understanding Personalization
        impact](https://www.algolia.com/doc/guides/personalization/personalizing-results/in-depth/configuring-personalization/#understanding-personalization-impact).
      default: 100
      minimum: 0
      maximum: 100
      x-categories:
        - Personalization
    restrictSearchableAttributes:
      type: array
      items:
        type: string
      example:
        - title
        - author
      description: |
        Restricts a search to a subset of your searchable attributes.
        Attribute names are case-sensitive.
      default: []
      x-categories:
        - Filtering
    ruleContexts:
      type: array
      items:
        type: string
      description: >
        Assigns a rule context to the search query

        [Rule
        contexts](https://www.algolia.com/doc/guides/managing-results/rules/rules-overview/how-to/customize-search-results-by-platform/#whats-a-context)
        are strings that you can use to trigger matching rules.
      default: []
      example:
        - mobile
      x-categories:
        - Rules
    similarQuery:
      type: string
      description: >
        Keywords to be used instead of the search query to conduct a more
        broader search

        Using the `similarQuery` parameter changes other settings

        - `queryType` is set to `prefixNone`.

        - `removeStopWords` is set to true.

        - `words` is set as the first ranking criterion.

        - All remaining words are treated as `optionalWords`

        Since the `similarQuery` is supposed to do a broad search, they usually
        return many results.

        Combine it with `filters` to narrow down the list of results.
      default: ''
      example: comedy drama crime Macy Buscemi
      x-categories:
        - Search
    sumOrFiltersScores:
      type: boolean
      description: >
        Whether to sum all filter scores

        If true, all filter scores are summed.

        Otherwise, the maximum filter score is kept.

        For more information, see [filter
        scores](https://www.algolia.com/doc/guides/managing-results/refine-results/filtering/in-depth/filter-scoring/#accumulating-scores-with-sumorfiltersscores).
      default: false
      x-categories:
        - Filtering
    synonyms:
      type: boolean
      description: Whether to take into account an index's synonyms for this search.
      default: true
      x-categories:
        - Advanced
    tagFilters:
      description: >
        Filter the search by values of the special `_tags` attribute.


        **Prefer using the `filters` parameter, which supports all filter types
        and combinations with boolean operators.**


        Different from regular facets, `_tags` can only be used for filtering
        (including or excluding records).

        You won't get a facet count.

        The same combination and escaping rules apply as for `facetFilters`.
      example:
        - - Book
          - Movie
        - SciFi
      oneOf:
        - type: array
          items:
            $ref: '#/components/schemas/tagFilters'
        - type: string
      x-categories:
        - Filtering
    userToken:
      type: string
      description: >
        Unique pseudonymous or anonymous user identifier.


        This helps with analytics and click and conversion events.

        For more information, see [user
        token](https://www.algolia.com/doc/guides/sending-events/concepts/usertoken).
      example: test-user-123
      x-categories:
        - Personalization
    query:
      type: string
      description: Search query.
      default: ''
      x-categories:
        - Search
    advancedSyntax:
      type: boolean
      description: >
        Whether to support phrase matching and excluding words from search
        queries

        Use the `advancedSyntaxFeatures` parameter to control which feature is
        supported.
      default: false
      x-categories:
        - Query strategy
    IndexSettings_advancedSyntaxFeatures:
      type: array
      items:
        $ref: '#/components/schemas/advancedSyntaxFeatures'
      description: |
        Advanced search syntax features you want to support
        - `exactPhrase`.
          Phrases in quotes must match exactly.
          For example, `sparkly blue "iPhone case"` only returns records with the exact string "iPhone case"
        - `excludeWords`.
          Query words prefixed with a `-` must not occur in a record.
          For example, `search -engine` matches records that contain "search" but not "engine"
        This setting only has an effect if `advancedSyntax` is true.
      default:
        - exactPhrase
        - excludeWords
      x-categories:
        - Query strategy
    allowTyposOnNumericTokens:
      type: boolean
      description: |
        Whether to allow typos on numbers in the search query
        Turn off this setting to reduce the number of irrelevant matches
        when searching in large sets of similar numbers.
      default: true
      x-categories:
        - Typos
    IndexSettings_alternativesAsExact:
      type: array
      items:
        $ref: '#/components/schemas/alternativesAsExact'
      description: >
        Determine which plurals and synonyms should be considered an exact
        matches

        By default, Algolia treats singular and plural forms of a word, and
        single-word synonyms, as
        [exact](https://www.algolia.com/doc/guides/managing-results/relevance-overview/in-depth/ranking-criteria/#exact)
        matches when searching.

        For example

        - "swimsuit" and "swimsuits" are treated the same

        - "swimsuit" and "swimwear" are treated the same (if they are
        [synonyms](https://www.algolia.com/doc/guides/managing-results/optimize-search-results/adding-synonyms/#regular-synonyms))

        - `ignorePlurals`.
          Plurals and similar declensions added by the `ignorePlurals` setting are considered exact matches
        - `singleWordSynonym`.
          Single-word synonyms, such as "NY" = "NYC", are considered exact matches
        - `multiWordsSynonym`.
          Multi-word synonyms, such as "NY" = "New York", are considered exact matches.
      default:
        - ignorePlurals
        - singleWordSynonym
      x-categories:
        - Query strategy
    attributeCriteriaComputedByMinProximity:
      type: boolean
      description: >
        Whether the best matching attribute should be determined by minimum
        proximity

        This setting only affects ranking if the Attribute ranking criterion
        comes before Proximity in the `ranking` setting.

        If true, the best matching attribute is selected based on the minimum
        proximity of multiple matches.

        Otherwise, the best matching attribute is determined by the order in the
        `searchableAttributes` setting.
      default: false
      x-categories:
        - Advanced
    attributesToHighlight:
      type: array
      items:
        type: string
      example:
        - author
        - title
        - conten
        - content
      description: >
        Attributes to highlight

        By default, all searchable attributes are highlighted.

        Use `*` to highlight all attributes or use an empty array `[]` to turn
        off highlighting.

        Attribute names are case-sensitive

        With highlighting, strings that match the search query are surrounded by
        HTML tags defined by `highlightPreTag` and `highlightPostTag`.

        You can use this to visually highlight matching parts of a search query
        in your UI

        For more information, see [Highlighting and
        snippeting](https://www.algolia.com/doc/guides/building-search-ui/ui-and-ux-patterns/highlighting-snippeting/js).
      x-categories:
        - Highlighting and Snippeting
[...]
